
use builtin;
use str;

set edit:completion:arg-completer[wpaperctl] = {|@words|
    fn spaces {|n|
        builtin:repeat $n ' ' | str:join ''
    }
    fn cand {|text desc|
        edit:complex-candidate $text &display=$text' '(spaces (- 14 (wcswidth $text)))$desc
    }
    var command = 'wpaperctl'
    for word $words[1..-1] {
        if (str:has-prefix $word '-') {
            break
        }
        set command = $command';'$word
    }
    var completions = [
        &'wpaperctl'= {
            cand -h 'Print help'
            cand --help 'Print help'
            cand -V 'Print version'
            cand --version 'Print version'
            cand get-wallpaper 'get-wallpaper'
            cand get 'get'
            cand all-wallpapers 'all-wallpapers'
            cand get-all 'get-all'
            cand next-wallpaper 'next-wallpaper'
            cand next 'next'
            cand previous-wallpaper 'previous-wallpaper'
            cand previous 'previous'
            cand reload-wallpaper 'reload-wallpaper'
            cand reload 'reload'
            cand pause-wallpaper 'pause-wallpaper'
            cand pause 'pause'
            cand resume-wallpaper 'resume-wallpaper'
            cand resume 'resume'
            cand toggle-pause-wallpaper 'toggle-pause-wallpaper'
            cand toggle-pause 'toggle-pause'
            cand get-status 'get-status'
            cand status 'status'
            cand help 'Print this message or the help of the given subcommand(s)'
        }
        &'wpaperctl;get-wallpaper'= {
            cand -h 'Print help'
            cand --help 'Print help'
        }
        &'wpaperctl;get'= {
            cand -h 'Print help'
            cand --help 'Print help'
        }
        &'wpaperctl;all-wallpapers'= {
            cand -j 'j'
            cand --json 'json'
            cand -h 'Print help'
            cand --help 'Print help'
        }
        &'wpaperctl;get-all'= {
            cand -j 'j'
            cand --json 'json'
            cand -h 'Print help'
            cand --help 'Print help'
        }
        &'wpaperctl;next-wallpaper'= {
            cand -h 'Print help'
            cand --help 'Print help'
        }
        &'wpaperctl;next'= {
            cand -h 'Print help'
            cand --help 'Print help'
        }
        &'wpaperctl;previous-wallpaper'= {
            cand -h 'Print help'
            cand --help 'Print help'
        }
        &'wpaperctl;previous'= {
            cand -h 'Print help'
            cand --help 'Print help'
        }
        &'wpaperctl;reload-wallpaper'= {
            cand -h 'Print help'
            cand --help 'Print help'
        }
        &'wpaperctl;reload'= {
            cand -h 'Print help'
            cand --help 'Print help'
        }
        &'wpaperctl;pause-wallpaper'= {
            cand -h 'Print help'
            cand --help 'Print help'
        }
        &'wpaperctl;pause'= {
            cand -h 'Print help'
            cand --help 'Print help'
        }
        &'wpaperctl;resume-wallpaper'= {
            cand -h 'Print help'
            cand --help 'Print help'
        }
        &'wpaperctl;resume'= {
            cand -h 'Print help'
            cand --help 'Print help'
        }
        &'wpaperctl;toggle-pause-wallpaper'= {
            cand -h 'Print help'
            cand --help 'Print help'
        }
        &'wpaperctl;toggle-pause'= {
            cand -h 'Print help'
            cand --help 'Print help'
        }
        &'wpaperctl;get-status'= {
            cand -j 'j'
            cand --json 'json'
            cand -h 'Print help'
            cand --help 'Print help'
        }
        &'wpaperctl;status'= {
            cand -j 'j'
            cand --json 'json'
            cand -h 'Print help'
            cand --help 'Print help'
        }
        &'wpaperctl;help'= {
            cand get-wallpaper 'get-wallpaper'
            cand all-wallpapers 'all-wallpapers'
            cand next-wallpaper 'next-wallpaper'
            cand previous-wallpaper 'previous-wallpaper'
            cand reload-wallpaper 'reload-wallpaper'
            cand pause-wallpaper 'pause-wallpaper'
            cand resume-wallpaper 'resume-wallpaper'
            cand toggle-pause-wallpaper 'toggle-pause-wallpaper'
            cand get-status 'get-status'
            cand help 'Print this message or the help of the given subcommand(s)'
        }
        &'wpaperctl;help;get-wallpaper'= {
        }
        &'wpaperctl;help;all-wallpapers'= {
        }
        &'wpaperctl;help;next-wallpaper'= {
        }
        &'wpaperctl;help;previous-wallpaper'= {
        }
        &'wpaperctl;help;reload-wallpaper'= {
        }
        &'wpaperctl;help;pause-wallpaper'= {
        }
        &'wpaperctl;help;resume-wallpaper'= {
        }
        &'wpaperctl;help;toggle-pause-wallpaper'= {
        }
        &'wpaperctl;help;get-status'= {
        }
        &'wpaperctl;help;help'= {
        }
    ]
    $completions[$command]
}
